﻿Type=Class
Version=3.61
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'RPiHowTo HelloWorld
'Class helloworld 
Sub Class_Globals
	Private ws As WebSocket
	'GPIO 
	Public GPIOController As GpioController		'The controllor managing the GPIO
	Public GPIOPin1 As GpioPinDigitalOutput		'GPIO_GEN Pin1 defined as digitalout (= Physical Pin 12, Name GPIO18)
	'Switch
	Private btnTimerSwitch As JQueryElement		'Switch to start/stop the timer. Defined in index.html as <a class="w3-btn w3-theme-l3" id="btnhelloworld">Click me!</a>
	Private tftimerinterval As JQueryElement	'Blinkinterval in ms
	Private TimerSwitchState As Boolean			'Flag to show the switch state being True = ON or False = OFF
	Private SwitchCounter As Int				'Lets track how many timers the LED has blinked
	'Led
	Private lblLedStatus As JQueryElement		'Label showing Welcome. Defined in index.html as <div id="lblhelloworld"></div>
	'Timer
	Private Timer1 As Timer
End Sub

Public Sub Initialize
	
End Sub

'The user connects to the websocket via browser <URL>:51042. The html file www/index.html is displayed.
Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
'	Log("WebSocket_Connected :: Start")
	ws = WebSocket1
'	Log("GPIOInit :: Start")
	Try
		GPIOController.Initialize
	Catch
		Log("GPIO Controller Initialize Error:" & CRLF & LastException.Message)
		Return
	End Try
	'Set the GPIO Digital Output Pin (GpioPinDigitalOutput) number 1 with state low.
	GPIOPin1.Initialize(1, False)
	GPIOPin1.State = False
	btnTimerSwitch.SetHtml("Switch Timer On")
	TimerSwitchState = False
	SwitchCounter = 0
	lblLedStatus.setHtml(" The LED is switched <B>OFF</B>.")
End Sub

'Not used
Private Sub WebSocket_Disconnected

End Sub

'Handle the timer tickets
Sub LEDTimer_Tick
	Dim state As String ="OFF"
	'Change the Pin1 state
	GPIOPin1.State = Not(GPIOPin1.State)
	'Increase the counter
	SwitchCounter = SwitchCounter + 1
	If GPIOPin1.State = True Then state = "ON"
	'Update the status message using smartstring
	lblLedStatus.setHtml($" LED switched <B>${state}</B> (${SwitchCounter} times)."$)
	'Do not forget to trigger flushing the outputsteam. This will refresh the page.
	ws.Flush
'   	Log("Switched LED to state " & GPIOPin1.State)
End Sub

Sub btnTimerSwitch_click(params As Map)
'	Log("btnSwitchLed_click :: Start = Parameter: " & params.Size)
	If TimerSwitchState = False Then
		'Get the interval from the inputfield. Do checks if isnumber and if value > 0
		Dim intervals As String = tftimerinterval.GetVal.Value
		If IsNumber(intervals) = False Then
			lblLedStatus.setHtml("Wrong Number specified for the Timer Interval.")
			ws.Flush
			Return
		End If
		Dim interval As Long = intervals
		If interval <= 0 Then
			lblLedStatus.setHtml("The Timer Interval must be greater 0 ms.")
			ws.Flush
			Return
		End If
		'Init the timer with the interval specified and update the switch label
		Timer1.Initialize("LEDTimer", interval)
		TimerSwitchState = True
		btnTimerSwitch.SetHtml("Switch the Timer <b>OFF</b>")
		SwitchCounter = 0
		lblLedStatus.setHtml("The Timer is started.")
		ws.Flush
	Else
		TimerSwitchState = False
		btnTimerSwitch.SetHtml("Switch the Timer <b>ON</b>")
		lblLedStatus.setHtml("Nothing to do as the Timer is switched OFF.")
		ws.Flush
	End If
	'Set the timer
	Timer1.Enabled = TimerSwitchState 
'	Log("btnSwitchLed_click :: End")
End Sub
